define(function(require) {
	var $ = require("jquery");
	var justep = require("$UI/system/lib/justep");

	require("$UI/system/lib/cordova/cordova");
	require("cordova!cordova-plugin-device");
	require("cordova!cordova-plugin-camera");
	require("cordova!cordova-plugin-media-capture");
	require("cordova!cordova-plugin-inappbrowser");
	require("cordova!cordova-plugin-file");
	require("cordova!cordova-plugin-file-transfer");

	var me;

	var Model = function() {
		this.callParent();

		me = this;
	};

	/**
	 * 
	 * 
	 * @date 2018-1-30 下午4:20:59
	 * @author shaoyi
	 * @project example
	 * @Description 拍照、摄像
	 * 
	 */

	/**
	 * 摄像
	 * 
	 */
	Model.prototype.shootVideos = function() {

		var fileData = this.comp("fileData");

		var captureParams = [];

		var captureSuccess = function(mediaFiles) {
			var i, path, len;
			for (i = 0, len = mediaFiles.length; i < len; i += 1) {
				path = mediaFiles[i].fullPath;

				/*
				 * iphone不能播放 resolveLocalFileSystemURI(path, function(e) {
				 * debugger; var fileEntry = e; path = e.toURL();
				 * alert(e.toURL()); }, function(){});
				 */

				captureParams.push({
					"filePath" : path,
					"fileName" : mediaFiles[i].name,
					"createTime" : justep.Date.toString(new Date(mediaFiles[i].lastModifiedDate), justep.Date.DEFAULT_FORMAT)
				});

				createThumbnail({
					"filePath" : path,
					"fileName" : mediaFiles[i].name,
					"createTime" : justep.Date.toString(new Date(mediaFiles[i].lastModifiedDate), justep.Date.DEFAULT_FORMAT)
				});

			}

			alert(JSON.stringify(captureParams));

			me._captureParams = captureParams[0];
		};

		var captureError = function(error) {
			alert("失败");
		};

		navigator.device.capture.captureVideo(captureSuccess, captureError, {
			limit : 1
		});

		function createThumbnail(datas) {
			// 创建视频缩略图
			VideoEditor.createThumbnail(function(result) {

				var thumbnailImageLocalURL = "file://" + result;

				window.resolveLocalFileSystemURL(thumbnailImageLocalURL, function(fileEntry) {
					fileEntry.file(function(file) {
						var reader = new FileReader();
						reader.onloadend = function(e) {
							fileData.loadData([ {
								"filePath" : datas.filePath,
								"fileName" : datas.fileName,
								"createTime" : datas.createTime,
								"thumbnailPath" : thumbnailImageLocalURL,
								"thumbnailImage" : e.target.result
							} ], true);

						};
						reader.readAsDataURL(file);
					}, function() {
						alert("读取失败");
					});
				}, function() {
					alert("失败");
				});

			}, // success cb
			function(msg) {
				alert("errorrr");
				alert(msg);
			}, // error cb
			{
				fileUri : datas.filePath, // the path to the video on the
				// device
				outputFileName : 'output-name', // the file name for the JPEG
				// image
				atTime : 2, // optional, location in the video to create the
				// thumbnail (in seconds)
				width : 320, // optional, width of the thumbnail
				height : 480, // optional, height of the thumbnail
				quality : 100
			// optional, quality of the thumbnail (between 1 and 100)
			});
		}

	};

	/**
	 * 获得视频信息
	 * 
	 * @param event
	 */
	Model.prototype.getVideoInfo = function(event) {

		var row = event.bindingContext.$object;

		var getVideoInfoSuccess = function(info) {
			alert('getVideoInfoSuccess, info: ' + JSON.stringify(info, null, 2));
			// info is a JSON object with the following properties -
			// {
			// width: 1920,
			// height: 1080,
			// orientation: 'landscape', // will be portrait or landscape
			// duration: 3.541, // duration in seconds
			// size: 6830126, // size of the video in bytes
			// bitrate: 15429777 // bitrate of the video in bits per second
			// }
		};

		var getVideoInfoError = function(msg) {
			alert('getVideoInfoError, msg: ' + JSON.stringify(msg));
		};

		VideoEditor.getVideoInfo(getVideoInfoSuccess, getVideoInfoError, {
			fileUri : row.val("filePath")
		});

	};

	/**
	 * 摄像上传
	 * 
	 */
	Model.prototype.uploadCapture = function() {

		var progressDiv = $(this.getElementByXid("progressDiv")); // 获取当前行的进度条XID
		var divProgress = $(this.getElementByXid("progressbar1"));

		var captureParams = this._captureParams;

		var ft = new FileTransfer();
		var path = captureParams.filePath, name = captureParams.fileName;

		var uploadUrl = "";

		ft.onprogress = function(progressEvent) {
			var percentProgress = parseInt((progressEvent.loaded / progressEvent.total) * 100) + "%";
			if (progressEvent.lengthComputable) {
				divProgress.css("width", percentProgress);
				divProgress.html(percentProgress);
			}
		};

		ft.upload(path, encodeURI(uploadUrl), function(result) {
			alert("success");
			alert(JSON.stringify(result));
			console.log('Upload success: ' + result.responseCode);
			console.log(result.bytesSent + ' bytes sent');
		}, function(error) {
			alert("error");
			console.log('Error uploading file ' + path + ': ' + error.code);
		}, {
			fileName : name
		});

	};

	return Model;
});